#ifndef _SIMPLICIAL_COMPLEX_IO_TET_FILE_H_
#define _SIMPLICIAL_COMPLEX_IO_TET_FILE_H_

#include <iostream>


template<int N>
class SimplicialComplex;

/**
* @class TET_File
* @ingroup mesh_io
*
* File syntax:
* <pre>
*     <em>v</em> vertices
*     <em>t</em> tets
*     <em>x<sub>1</sub> y<sub>1</sub> z<sub>1</sub></em>
*     ...
*     4 <em>v<sub>1</sub></em> <em>v<sub>2</sub></em> <em>v<sub>3</sub> <em>v<sub>4</sub></em></em>
*     ...
* </pre>
*
* @see TET_File::Read
*/
class TET_File
{
public:
    /**
    * Builds a mesh from a file in the TET file format.
    * @return true if successful
    */
    static bool Read( SimplicialComplex<3>& mesh, std::istream& in );
};


#endif  // _SIMPLICIAL_COMPLEX_IO_TET_FILE_H_
