#ifndef _MESH_FACTORY_H_
#define _MESH_FACTORY_H_


//////////////////////////////////////////////////////////////////////////////
// Includes

#include "simplicialComplex/simplicialComplex.h"


//////////////////////////////////////////////////////////////////////////////
// class MeshFactory
// Builds SimplicialComplex objects.

template<int N>
class MeshFactory
{
};

template<>
class MeshFactory<3>
{
public:  // methods
    MeshFactory( SimplicialComplex<3>& mesh );
    ~MeshFactory();

    bool Build( const std::vector< vec3 >& vertexPositions, const std::vector< vec<4,int> >& tets );

private:  // typedefs
    typedef SimplicialComplex<3>::S0List::const_iterator S0ListIter;
    typedef SimplicialComplex<3>::S1List::const_iterator S1ListIter;
    typedef SimplicialComplex<3>::S2List::const_iterator S2ListIter;
    typedef SimplicialComplex<3>::S3List::const_iterator S3ListIter;
    typedef SimplicialComplex<3>::SignedIndex SignedIndex;

private:  // methods
    MeshFactory( const MeshFactory& );
    MeshFactory& operator=( const MeshFactory& );

    bool MakeVertex( int v0, const vec3& position );
    bool MakeTet( int v0, int v1, int v2, int v3 );

    bool BuildFaces();
    bool BuildEdges();

    bool BuildAdjacencyVE();
    bool BuildAdjacencyEF();
    bool BuildAdjacencyFT();
    bool BuildAdjacencyET();

    bool CalculateVolumes();

private:  // data
    SimplicialComplex<3>& sc;
};


#endif  // _MESH_FACTORY_H_
