
//////////////////////////////////////////////////////////////////////////////
// Includes

#include "util/bbox.h"


//////////////////////////////////////////////////////////////////////////////
// intersect with box

bool BBox::Intersect( const BBox& bb ) const
{
    return ( ( bb.vmin[0] <= vmax[0] && bb.vmax[0] >= vmin[0] ) &&
             ( bb.vmin[1] <= vmax[1] && bb.vmax[1] >= vmin[1] ) &&
             ( bb.vmin[2] <= vmax[2] && bb.vmax[2] >= vmin[2] ) );
}

//////////////////////////////////////////////////////////////////////////////
// intersect with point

bool BBox::Intersect( const vec3& point ) const
{
    return ( vmin[0] <= point[0] && point[0] <= vmax[0] && 
             vmin[1] <= point[1] && point[1] <= vmax[1] && 
             vmin[2] <= point[2] && point[2] <= vmax[2] );
}
